package com.zhongzheng.modules.user.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;
import com.zhongzheng.modules.user.bo.UserCourseAnswerAddBo;
import com.zhongzheng.modules.user.bo.UserCourseAnswerQueryBo;
import com.zhongzheng.modules.user.bo.UserCourseAnswerEditBo;
import com.zhongzheng.modules.user.domain.UserCourseAnswer;
import com.zhongzheng.modules.user.mapper.UserCourseAnswerMapper;
import com.zhongzheng.modules.user.vo.UserCourseAnswerVo;
import com.zhongzheng.modules.user.service.IUserCourseAnswerService;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 答疑Service业务层处理
 *
 * @author ruoyi
 * @date 2021-12-15
 */
@Service
public class UserCourseAnswerServiceImpl extends ServiceImpl<UserCourseAnswerMapper, UserCourseAnswer> implements IUserCourseAnswerService {

    @Override
    public UserCourseAnswerVo queryById(Long answerId){
        UserCourseAnswer db = this.baseMapper.selectById(answerId);
        return BeanUtil.toBean(db, UserCourseAnswerVo.class);
    }

    @Override
    public List<UserCourseAnswerVo> queryList(UserCourseAnswerQueryBo bo) {
        return baseMapper.selectAnswer(bo);
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<UserCourseAnswerVo> entity2Vo(Collection<UserCourseAnswer> collection) {
        List<UserCourseAnswerVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, UserCourseAnswerVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<UserCourseAnswer> page = (Page<UserCourseAnswer>)collection;
            Page<UserCourseAnswerVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(UserCourseAnswerAddBo bo) {
        UserCourseAnswer add = BeanUtil.toBean(bo, UserCourseAnswer.class);
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(UserCourseAnswerEditBo bo) {
        UserCourseAnswer update = BeanUtil.toBean(bo, UserCourseAnswer.class);
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(UserCourseAnswer entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
